package com.appsallglobal.statuswalls;

import android.content.ActivityNotFoundException;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;

import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.annotation.NonNull;
import androidx.appcompat.app.ActionBarDrawerToggle;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;
import androidx.core.view.GravityCompat;
import androidx.drawerlayout.widget.DrawerLayout;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.google.android.material.appbar.MaterialToolbar;
import com.google.android.material.bottomnavigation.BottomNavigationView;
import com.google.android.material.button.MaterialButton;
import com.google.android.material.navigation.NavigationBarView;
import com.google.android.material.navigation.NavigationView;

public class MainActivity extends AppCompatActivity {



    DrawerLayout drawerLayout;
    MaterialToolbar materialToolbar;
    BottomNavigationView bottomNavigationView;
    NavigationView navigationView;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);



        setContentView(R.layout.activity_main);

////////////////poricoy
drawerLayout = findViewById(R.id.main);
materialToolbar = findViewById(R.id.materialToolbar);
bottomNavigationView = findViewById(R.id.bottomnavigation);
navigationView = findViewById(R.id.navigation);

//////////end find

////////////// make a drawer
        // Create ActionBarDrawerToggle and sync the state
      ActionBarDrawerToggle toggle = new ActionBarDrawerToggle(
                this,
                drawerLayout,
                materialToolbar,
                R.string.navigation_drawer_open,
                R.string.navigation_drawer_close
        );

        drawerLayout.addDrawerListener(toggle);

        FragmentManager manager = getSupportFragmentManager();
        FragmentTransaction fragmentTransaction = manager.beginTransaction();
        fragmentTransaction.replace(R.id.framlayout1,new HomeFragment());
        materialToolbar.setTitle("Statuswalls");

        fragmentTransaction.commit();
//////////////////end a drawer

askNotificationPermission();
        // Create GDPR Class Object and call setGDPR method
        GDPR gdpr = new GDPR(MainActivity.this);
        gdpr.setGDPR();
navigationView.setNavigationItemSelectedListener(new NavigationView.OnNavigationItemSelectedListener() {
    @Override
    public boolean onNavigationItemSelected(@NonNull MenuItem item) {



        if (item.getItemId()==R.id.status_Dr){


            startActivity(new Intent(MainActivity.this, StatusCatagorActivityy.class));
            drawerLayout.closeDrawer(GravityCompat.START);
        } else if (item.getItemId()==R.id.quotes_dr) {

            startActivity(new Intent(MainActivity.this, QuotesActivity.class));
            drawerLayout.closeDrawer(GravityCompat.START);


        } else if (item.getItemId()==R.id.share_app_dr) {

            shareApp();
            drawerLayout.closeDrawer(GravityCompat.START);

        } else if (item.getItemId()==R.id.Contrac_dr) {

            email();
drawerLayout.closeDrawer(GravityCompat.START);

        } else if (item.getItemId()==R.id.exit_dr) {

showCustomAlertDialog2();



drawerLayout.closeDrawer(GravityCompat.START);
        } else if (item.getItemId()==R.id.developer_dr) {

            showCustomAlertDialog();
            drawerLayout.closeDrawer(GravityCompat.START);

        } else if (item.getItemId()==R.id.data_removea_dr) {

new android.app.AlertDialog.Builder(MainActivity.this)
        .setMessage("Please email us, and we will ensure that your data is deleted within 90 days.")
        .setNegativeButton("No", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        })
        .setPositiveButton("Yes ", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
String email = "Ferdousi0135@gmail.com";
                String box = "Please email us, and we will ensure that your data is deleted within 90 days.";


                send_email(box,email);


            }
        })
        .show();

            drawerLayout.closeDrawer(GravityCompat.START);


        } else if (item.getItemId()==R.id.about_as) {
            startActivity(new Intent(MainActivity.this, Abouts_us.class));
            drawerLayout.closeDrawer(GravityCompat.START);

        } else if (item.getItemId()==R.id.privacy_Policy) {
            String pl = "https://sites.google.com/view/privacy-policy-statuswalls";
            Intent browserIntent = new Intent(Intent.ACTION_VIEW, Uri.parse(pl));
            startActivity(browserIntent);
drawerLayout.closeDrawer( GravityCompat.START);

        }


        return true;
    }
});






        bottomNavigationView.setOnItemSelectedListener(new NavigationBarView.OnItemSelectedListener() {
            @Override
            public boolean onNavigationItemSelected(@NonNull MenuItem item) {

                if (item.getItemId()==R.id.home_b){




                    FragmentManager manager = getSupportFragmentManager();
                    FragmentTransaction fragmentTransaction = manager.beginTransaction();
                    fragmentTransaction.replace(R.id.framlayout1,new HomeFragment());
                    materialToolbar.setTitle("Statuswalls");

                    fragmentTransaction.commit();

                } else {

                    FragmentManager manager = getSupportFragmentManager();
                    FragmentTransaction fragmentTransaction = manager.beginTransaction();
                    fragmentTransaction.replace(R.id.framlayout1,new RepeatorFragment());
                    materialToolbar.setTitle(" Status Repeator");
                    fragmentTransaction.commit();





                }



                return true;
            }
        });




    }

    private void email() {
        String subject = "Contacts with Statuswalls Apps ";
        String bodyText = "How I can help you ? please write now.";
        String myEmail = "Ferdousi0135@gmail.com";

        String mailto = "mailto:" + myEmail +
                "?cc=" +
                "&subject=" + Uri.encode(subject) +
                "&body=" + Uri.encode(bodyText);
        Intent emailIntent = new Intent(Intent.ACTION_SENDTO);
        emailIntent.setData(Uri.parse(mailto));
        try {
            startActivity(emailIntent);
        } catch (ActivityNotFoundException e) {
            Toast.makeText(MainActivity.this, "Download Email App", Toast.LENGTH_SHORT).show();
        }

    }


    private void shareApp() {
        Intent shareIntent = new Intent(Intent.ACTION_SEND);
        shareIntent.setType("text/plain");
        String shareMessage = "Check out this cool app: https://play.google.com/store/apps/details?id=" + getPackageName();
        shareIntent.putExtra(Intent.EXTRA_TEXT, shareMessage);
        startActivity(Intent.createChooser(shareIntent, "Share via"));
    }
    private void showCustomAlertDialog() {
        // Inflate the custom layout/view
        LayoutInflater inflater = getLayoutInflater();
        View customView = inflater.inflate(R.layout.alert_item, null);

        // Build the alert dialog
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setView(customView);

        // Set the dialog to be non-cancelable
        builder.setCancelable(false);

        // Reference to the view components in the layout
        Button emailButton = customView.findViewById(R.id.email_alt);
        Button alertButton = customView.findViewById(R.id.button);

        // Create and show the alert dialog
        AlertDialog alertDialog = builder.create();
        alertDialog.getWindow().setBackgroundDrawableResource(android.R.color.transparent);
        alertDialog.show();

        // Set click listener for the alertButton to dismiss the dialog
        alertButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                alertDialog.dismiss();
            }
        });

        // Set click listener for the emailButton to send an email
        emailButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String myEmail = "asifulislamasif032@gmail.com";
                String subject = "Contacts with developer\nHow can I help you? Please provide details and send me an email.";
             send_email(subject,myEmail);
            }
        });
    }

    private void send_email(String subject,String myEmail) {






        String mailto = "mailto:" + myEmail +
                "?cc=" +
                "&subject=" + Uri.encode(subject) +
                "&body=";

        Intent emailIntent = new Intent(Intent.ACTION_SENDTO);
        emailIntent.setData(Uri.parse(mailto));
        try {
            startActivity(emailIntent);
        } catch (ActivityNotFoundException e) {
            Toast.makeText(MainActivity.this, "Please download an email app", Toast.LENGTH_SHORT).show();
        }
    }




    // Declare the launcher at the top of your Activity/Fragment:
    private final ActivityResultLauncher<String> requestPermissionLauncher =
            registerForActivityResult(new ActivityResultContracts.RequestPermission(), isGranted -> {
                if (isGranted) {
                    // FCM SDK (and your app) can post notifications.

                } else {

                    // TODO: Inform the user that your app will not show notifications.
                }
            });

    private void askNotificationPermission() {
        // This is only necessary for API level >= 33 (TIRAMISU)
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
            if (ContextCompat.checkSelfPermission(this, android.Manifest.permission.POST_NOTIFICATIONS) ==
                    PackageManager.PERMISSION_GRANTED) {
                // FCM SDK (and your app) can post notifications.

            } else if (shouldShowRequestPermissionRationale(android.Manifest.permission.POST_NOTIFICATIONS)) {
                new android.app.AlertDialog.Builder(MainActivity.this)
                        .setTitle("Notification Permission")
                        .setMessage("To ensure the app functions correctly, notification permission is necessary.")
                        .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                requestPermissionLauncher.launch(android.Manifest.permission.POST_NOTIFICATIONS);
                            }
                        })
                        .setNegativeButton("No Thanks", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                            }
                        })
                        .show();
            } else {
                // Directly ask for the permission
                requestPermissionLauncher.launch(android.Manifest.permission.POST_NOTIFICATIONS);
            }
        }
    }

    @Override
    public void onBackPressed() {
     //   super.onBackPressed();



showCustomAlertDialog2();




    }



    private void showCustomAlertDialog2() {
        // If the activity is finishing, don't show the dialog
        if (isFinishing() || isDestroyed()) {
            return;
        }

        // Inflate the custom layout/view
        LayoutInflater inflater = getLayoutInflater();
        View customView = inflater.inflate(R.layout.network_item, null);

        // Build the alert dialog
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setView(customView);

        // Find buttons in custom view
        MaterialButton close = customView.findViewById(R.id.closeIdButton);
        MaterialButton closeapp = customView.findViewById(R.id.yesIdButton);

        // Create and show the alert dialog
        AlertDialog alertDialog = builder.create();
        if (alertDialog.getWindow() != null) {
            alertDialog.getWindow().setBackgroundDrawableResource(android.R.color.transparent);
        }
        alertDialog.show();

        // Set button click listeners
        closeapp.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                alertDialog.dismiss();
                finishAndRemoveTask();  // Closes the app
            }
        });

        close.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                alertDialog.dismiss();  // Closes the alert dialog
            }
        });
    }




}