package com.appsallglobal.statuswalls;

import static com.google.firebase.inappmessaging.internal.Logging.TAG;

import android.content.ContentResolver;
import android.content.ContentValues;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.cardview.widget.CardView;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.bumptech.glide.Glide;
import com.google.android.material.appbar.MaterialToolbar;
import com.google.android.material.button.MaterialButton;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;

public class MainActivity2 extends AppCompatActivity {

    static final int REQUEST_WRITE_STORAGE = 1;
    ImageView imageView;
    CardView cardView2;
    MaterialButton savedButton;
    MaterialToolbar materialToolbar;
     int tobD= 1;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main2);



        imageView = findViewById(R.id.imageViewRead);
        savedButton = findViewById(R.id.savedButton);
        cardView2 = findViewById(R.id.carView2);
        materialToolbar = findViewById(R.id.mmtt);
        materialToolbar.setNavigationOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                // Handle the navigation icon click here




                finish();
                // Example: If you want to finish the activity on click
                // finish();
            }
        });
        // Assuming HomeFragment.bitmap is initialized elsewhere
        Intent intent = getIntent();
        String imageUrl = intent.getStringExtra("image");
        Glide.with(this).load(imageUrl).into(imageView);
        savedButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                // Check for storage permission
                if (ContextCompat.checkSelfPermission(MainActivity2.this, android.Manifest.permission.WRITE_EXTERNAL_STORAGE)
                        != PackageManager.PERMISSION_GRANTED) {
                    ActivityCompat.requestPermissions(MainActivity2.this, new String[]{android.Manifest.permission.WRITE_EXTERNAL_STORAGE}, REQUEST_WRITE_STORAGE);
                } else {
                    // Permission already granted, save the image
                    saveButton(cardView2);
                    showHomepageADD();
                }
            }
        });
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if (requestCode == REQUEST_WRITE_STORAGE) {
            if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                // Permission granted, proceed with save
                saveButton(cardView2);
            } else {
                // Permission denied
                Toast.makeText(this, "Permission Denied", Toast.LENGTH_SHORT).show();
            }
        }
    }

    public void saveButton(CardView layout) {
        // Create a Bitmap from the CardView
        Bitmap bitmap = Bitmap.createBitmap(layout.getWidth(), layout.getHeight(), Bitmap.Config.ARGB_8888);
        Canvas canvas = new Canvas(bitmap);
        layout.draw(canvas); // Fix: use 'layout' instead of 'cardView2'

        try {
            save(bitmap);
        } catch (IOException e) {
            Toast.makeText(this, "Error saving image: " + e.getMessage(), Toast.LENGTH_LONG).show();
            Log.e(TAG, "Error saving image", e);
        }
    }

    private void save(Bitmap bitmap) throws IOException {
        OutputStream fos;

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.Q) {
            // For Android 10 and above
            ContentResolver resolver = getContentResolver();
            ContentValues contentValues = new ContentValues();
            contentValues.put(MediaStore.MediaColumns.DISPLAY_NAME, "Simple_image_" + System.currentTimeMillis() + ".jpg");
            contentValues.put(MediaStore.MediaColumns.MIME_TYPE, "image/jpeg");
            contentValues.put(MediaStore.MediaColumns.RELATIVE_PATH, Environment.DIRECTORY_PICTURES);

            Uri imageUri = resolver.insert(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, contentValues);
            if (imageUri != null) {
                fos = resolver.openOutputStream(imageUri);
            } else {
                throw new IOException("Failed to create new MediaStore record.");
            }
        } else {
            // For Android 9 and below
            String root = Environment.getExternalStorageDirectory().getAbsolutePath();
            File file = new File(root + "/Pictures");
            if (!file.exists()) {
                file.mkdirs();
            }

            String fileName = "Simple_image_" + System.currentTimeMillis() + ".jpg";
            File myFile = new File(file, fileName);
            if (myFile.exists()) {
                myFile.delete();
            }

            fos = new FileOutputStream(myFile);
        }

        try {
            bitmap.compress(Bitmap.CompressFormat.JPEG, 100, fos);
        } finally {
            fos.flush();
            fos.close();
        }

        Toast.makeText(this, "Image saved successfully", Toast.LENGTH_SHORT).show();
        showHomepageADD();
    }







    private void   showHomepageADD( ) {

        String url = "https://appsallglabal.com/Statuswall/Admob%20Ads%20Control/fullscreenads.php";
        StringRequest stringRequest = new StringRequest(Request.Method.GET, url, new Response.Listener<String>() {
            @Override
            public void onResponse(String response) {

                if (response.contains("on")){

                    if (ManageServer.mInterstitialAd != null) {
                        ManageServer.mInterstitialAd.show(MainActivity2.this);
                    } else {
                        Log.d("TAG", "The interstitial ad wasn't ready yet.");
                    }

                }






            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {

            }
        });
        RequestQueue queue = Volley.newRequestQueue(MainActivity2.this);

// Add the request to the queue
        queue.add(stringRequest);

    }

}
