package com.appsallglobal.statuswalls;

import android.content.ClipData;
import android.content.ClipboardManager;
import android.content.Context;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.os.Handler;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.airbnb.lottie.LottieAnimationView;
import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonArrayRequest;
import com.android.volley.toolbox.Volley;
import com.google.android.material.appbar.MaterialToolbar;
import com.squareup.picasso.Picasso;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Random;

public class QuotesActivity extends AppCompatActivity {
    MaterialToolbar materialToolbar;
    RecyclerView recyclerView;
    ProgressBar progressBarCat;
    HashMap<String,String> hashMap;
    ArrayList<HashMap<String,String>> arrayList = new ArrayList<>();

    private int[] imageList1 = {R.drawable.p1,  R.drawable.p3,R.drawable.p4,R.drawable.p6,R.drawable.tab1,R.drawable.tab2,R.drawable.tab3,R.drawable.tab4,R.drawable.tab5,R.drawable.tab6};
    String[] imageList = {
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab1.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab2.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab3.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab4.png",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab5.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab6.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab7.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab8.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab9.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab10.jpg"
    };

    //
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_quotes);
progressBarCat= findViewById(R.id.progresbarCat);
materialToolbar = findViewById(R.id.materialtolbarQues);
recyclerView = findViewById(R.id.recyclerview);

        materialToolbar.setNavigationOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                // Handle the navigation icon click here




                finish();
                // Example: If you want to finish the activity on click
                // finish();
            }
        });



serverQuotes();

    }

    private void serverQuotes() {


            String qUrl = "https://appsallglabal.com/Statuswall/Quotes/quotes.php";


            JsonArrayRequest jsonArrayRequest = new JsonArrayRequest(Request.Method.GET, qUrl, null, new Response.Listener<JSONArray>() {
                @Override
                public void onResponse(JSONArray response) {
progressBarCat.setVisibility(View.GONE);
                    for (int b = 0;b<response.length();b++) {

                        try {
                            JSONObject jsonObject = response.getJSONObject(b);




                            String item = jsonObject.getString("item");
                            String quotes = jsonObject.getString("quotes");
                            String writer = jsonObject.getString("witer");

                            hashMap = new HashMap<>();
                            hashMap.put("item",item);
                            hashMap.put("Quotes",quotes);
                            hashMap.put("Writer",writer);
                            arrayList.add(hashMap);

                            QAdapter adapter = new QAdapter();
                            recyclerView.setAdapter(adapter);
                            recyclerView.setLayoutManager(new LinearLayoutManager(QuotesActivity.this));


                        } catch (JSONException e) {
                            throw new RuntimeException(e);
                        }


                    }



                }
            }, new Response.ErrorListener() {
                @Override
                public void onErrorResponse(VolleyError error) {
                    progressBarCat.setVisibility(View.GONE);
                   // Toast.makeText(QuotesActivity.this, "Server is down", Toast.LENGTH_SHORT).show();
                     Toast.makeText(QuotesActivity.this, "Server is down\n"+error.getMessage(), Toast.LENGTH_SHORT).show();

                }
            });
// Initialize the request queue
            RequestQueue queue = Volley.newRequestQueue(QuotesActivity.this);

// Add the request to the queue
            queue.add(jsonArrayRequest);
        }





    private  class  QAdapter extends  RecyclerView.Adapter{


        int quotes_item = 0;
        int nativeadd_item = 1;


        private  class  quotesHolder extends  RecyclerView.ViewHolder{
            ImageView imageViewquotes;
            RelativeLayout write_body;
            TextView qTitle ,qWriter;
            RelativeLayout relativeLayout ;
            public quotesHolder(@NonNull View itemView) {
                super(itemView);

                imageViewquotes = itemView.findViewById(R.id.imageViewquotes);
                write_body =  itemView.findViewById(R.id.write_body);
                qTitle = itemView.findViewById(R.id.qTitle);
                qWriter = itemView.findViewById(R.id.qWriter);
                relativeLayout = itemView.findViewById(R.id.relativeLayot);


            }

            public void setBackground(int originalBackground) {





            }
        }

        private  class  nativeaddHolder extends  RecyclerView.ViewHolder{


            public nativeaddHolder(@NonNull View itemView) {
                super(itemView);
            }
        }




        @NonNull
        @Override
        public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
            LayoutInflater layoutInflater = LayoutInflater.from(parent.getContext());

            if (viewType == quotes_item) {
                View qView = layoutInflater.inflate(R.layout.quotes_item2, parent, false);
                return new quotesHolder(qView);
            } else if (viewType == nativeadd_item) {
                View nView = layoutInflater.inflate(R.layout.naive_item, parent, false);
                return new nativeaddHolder(nView);
            }

            // Ideally, this line should never be reached
            throw new IllegalArgumentException("Unexpected viewType: " + viewType);
        }

        @Override
        public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
            if (getItemViewType(position)==quotes_item){

                quotesHolder quotesHolder = (QAdapter.quotesHolder) holder;

                HashMap<String,String> hashMap1 = arrayList.get(position);


                String quotesTitle = hashMap1.get("Quotes");
                String quotesWriter = hashMap1.get("Writer");

                quotesHolder.qTitle.setText(quotesTitle);
                quotesHolder.qWriter.setText(quotesWriter);

               Random random = new Random();
              int randomIndex = random.nextInt(imageList1.length);
              quotesHolder.imageViewquotes.setImageResource(imageList1[randomIndex]);
              // Picasso.get().load(imageList[randomIndex]).placeholder(R.drawable.p7).error(R.drawable.p1).into(quotesHolder.imageViewquotes);

                Random rnd = new Random();
                int color = Color.argb(255, rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256));
                quotesHolder.write_body.setBackgroundColor(color);

                int originalColor = quotesHolder.qTitle.getCurrentTextColor(); // মূল কালার সংরক্ষণ
                Drawable originalBackground = quotesHolder.qTitle.getBackground();
                // মূল ব্যাকগ্রাউন্ড সংরক্ষণ
                quotesHolder.relativeLayout.setOnLongClickListener(new View.OnLongClickListener() {
                    @Override
                    public boolean onLongClick(View v) {
                        // কালার ও ব্যাকগ্রাউন্ড পরিবর্তন
                        quotesHolder.qTitle.setTextColor(Color.WHITE);
                        quotesHolder.qTitle.setBackgroundColor(Color.BLUE);
                        // ক্লিপবোর্ডে কপি
                        // ক্লিপবোর্ডে কপি
                        String stringbody = quotesHolder.qTitle.getText().toString()+"\n\n"+quotesHolder.qWriter.getText().toString();
                        ClipboardManager clipboard = (ClipboardManager) getSystemService(Context.CLIPBOARD_SERVICE);
                        ClipData clip = ClipData.newPlainText("label",
                                stringbody);
                        clipboard.setPrimaryClip(clip);


                        // টোস্ট মেসেজ দেখানো
                        Toast.makeText(getApplicationContext(), "Text copied to clipboard!", Toast.LENGTH_SHORT).show();


                        // 1 সেকেন্ড পরে আবার আগের মত হবে
                        new Handler().postDelayed(new Runnable() {
                            @Override
                            public void run() {
                                quotesHolder.qTitle.setTextColor(originalColor);
                                quotesHolder.qTitle.setBackground(originalBackground);
                            }
                        }, 1000);

                        return true;
                    }
                });
            }

        }

        @Override
        public int getItemCount() {
            return arrayList.size();
        }


        @Override
        public int getItemViewType(int position) {


            HashMap<String,String> hashMap1 = arrayList.get(position);
            String item = hashMap1.get("item");
            if (item.contains("quotes")) return  quotes_item;
            else  return  nativeadd_item;




        }
    }





}