package com.appsallglobal.statuswalls;

import android.app.Activity;
import android.content.ClipData;
import android.content.ClipboardManager;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;

import androidx.fragment.app.Fragment;

import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.google.android.material.button.MaterialButton;


public class RepeatorFragment extends Fragment {

    EditText edCountTextEdit;
    EditText edTextEdit;
    MaterialButton materialButton;
    RelativeLayout coppyRelative,shareRelative;
    private TextView tvDisplay ;
int rehomeCount=1;
    private  static  String  mycoppyText = "";
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {



        View repeatorview = inflater.inflate(R.layout.fragment_repeator, container, false);

        if (repeatorview!=null){


            materialButton =  repeatorview.findViewById(R.id.resultbutton);
            edTextEdit = repeatorview.findViewById(R.id.edtextEdit);
            edCountTextEdit = repeatorview.findViewById(R.id.edCountEdit);
            coppyRelative = repeatorview.findViewById(R.id.coppyRelative);
            shareRelative= repeatorview.findViewById(R.id.shareRelative);
            tvDisplay = repeatorview.findViewById(R.id.tvDisplay);
            calculateRepeat();

        }




        return repeatorview;
    }



    private void calculateRepeat() {

        materialButton.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                tvDisplay.setText("");

                String textString = edTextEdit.getText().toString();
                String contString = edCountTextEdit.getText().toString();
                mycoppyText = textString;

                if (textString.isEmpty()|| contString.isEmpty()){

                    Toast.makeText(getContext(), "Please fill in all fields", Toast.LENGTH_SHORT).show();

                } else {

                    int count = Integer.parseInt(contString);

                    if (count <= 9999) {
                        rehomeCount++;
                        // যদি count ৯৯৯৯ এর সমান বা ছোট হয়, তাহলে এই টোস্ট দেখাবে
                        Toast.makeText(getContext(), "Repeat Now", Toast.LENGTH_SHORT).show();

                        if (rehomeCount%2==0){
                           showHomepageADD();

                        }


                        int i = Integer.parseInt(contString);
                        for (int a = 1;a<=i;a++){

                            tvDisplay.append(""+textString+"\n");

                        }








                        copyshare();
                    } else {
                        // যদি count ৯৯৯৯ এর বেশি হয়, তাহলে এই টোস্ট দেখাবে
                        Toast.makeText(getContext(), "You can repeat a maximum of 9999 times", Toast.LENGTH_SHORT).show();
                    }


                }


            }
        });





    }

    private  void  copyshare (){
        String textString = edTextEdit.getText().toString();
        String contString = edCountTextEdit.getText().toString();



        coppyRelative.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {


                if (textString.isEmpty()|| contString.isEmpty()){

                    Toast.makeText(getContext(), "Please fill in all fields", Toast.LENGTH_SHORT).show();

                } else {



                    String myText = tvDisplay.getText().toString();
                    if (!myText.isBlank()){



                        // copy করার জন্য এর কোড লেখা হয়েছে
                        ClipboardManager clipboard = (ClipboardManager) getActivity().getSystemService(Context.CLIPBOARD_SERVICE);
                        ClipData clip = ClipData.newPlainText("Copied Text", myText);
                        clipboard.setPrimaryClip(clip);

                        // কপি করা হলে Toast show করিয়ে দেওয়া হয়েছে
                        Toast.makeText(getActivity(), "Text Copied", Toast.LENGTH_SHORT).show();


                    } else {

                        Toast.makeText(getContext(), "Something is wrong", Toast.LENGTH_SHORT).show();
                    }





                }



            }
        });



        shareRelative.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                if (textString.isEmpty()|| contString.isEmpty()){

                    Toast.makeText(getContext(), "Please fill in all fields", Toast.LENGTH_SHORT).show();

                }else {

                    String myText = tvDisplay.getText().toString();
                    if (!myText.isBlank()){
                        String textToShare = tvDisplay.getText().toString();
                        if (!textToShare.isEmpty()) {
                            shareText(textToShare);
                        }





                    } else {

                        Toast.makeText(getContext(), "Something is wrong", Toast.LENGTH_SHORT).show();
                    }



                }



            }
        });




    }

    private void shareText(String text) {
        Intent sendIntent = new Intent();
        sendIntent.setAction(Intent.ACTION_SEND);
        sendIntent.putExtra(Intent.EXTRA_TEXT, text);
        sendIntent.setType("text/plain");

        Intent shareIntent = Intent.createChooser(sendIntent, null);
        startActivity(shareIntent);
    }






    private void   showHomepageADD( ) {

        String url = "https://appsallglabal.com/Statuswall/Admob%20Ads%20Control/fullscreenads.php";
        StringRequest stringRequest = new StringRequest(Request.Method.GET, url, new Response.Listener<String>() {
            @Override
            public void onResponse(String response) {

                if (response.contains("on")){

                    if (ManageServer.mInterstitialAd != null) {
                        ManageServer.mInterstitialAd.show(getActivity());
                    } else {
                        Log.d("TAG", "The interstitial ad wasn't ready yet.");
                    }

                }






            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {

            }
        });
        RequestQueue queue = Volley.newRequestQueue(getContext());

// Add the request to the queue
        queue.add(stringRequest);

    }












}