package com.appsallglobal.statuswalls;

import static com.appsallglobal.statuswalls.MainActivity2.REQUEST_WRITE_STORAGE;
import static com.google.firebase.inappmessaging.internal.Logging.TAG;

import android.app.WallpaperManager;
import android.content.ContentResolver;
import android.content.ContentValues;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.cardview.widget.CardView;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.bumptech.glide.Glide;
import com.google.android.material.appbar.MaterialToolbar;
import com.squareup.picasso.Callback;
import com.squareup.picasso.Picasso;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;

public class SeeWallapaperActivity extends AppCompatActivity {
ImageView imageView;
MaterialToolbar materialToolbar;
public  static  String wUrl = null;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_see_wallapaper);

imageView = findViewById(R.id.imageviewWall);

materialToolbar = findViewById(R.id.lastMMMM);

        Intent intent = getIntent();
        String imageUrl = intent.getStringExtra("image");
        Glide.with(this).load(imageUrl).into(imageView);

materialToolbar.setOnMenuItemClickListener(new Toolbar.OnMenuItemClickListener() {
    @Override
    public boolean onMenuItemClick(MenuItem item) {
if (item.getItemId()==R.id.download_Wal){


    if (ContextCompat.checkSelfPermission(SeeWallapaperActivity.this, android.Manifest.permission.WRITE_EXTERNAL_STORAGE)
            != PackageManager.PERMISSION_GRANTED) {
        ActivityCompat.requestPermissions(SeeWallapaperActivity.this, new String[]{android.Manifest.permission.WRITE_EXTERNAL_STORAGE}, REQUEST_WRITE_STORAGE);
    } else {
        // Permission already granted, save the image
        saveButton(imageView);

showHomepageADD();

    }



} else {
    wall();
showHomepageADD();



}


        return false;
    }
});





        materialToolbar.setNavigationOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                // Handle the navigation icon click here




                finish();
                // Example: If you want to finish the activity on click
                // finish();
            }
        });









    }

    private void wall() {



        Drawable drawable = imageView.getDrawable();
        if (drawable != null && drawable instanceof BitmapDrawable) {
            Bitmap bitmap = ((BitmapDrawable) drawable).getBitmap();

            // Resize bitmap to match the screen dimensions
            DisplayMetrics metrics = getResources().getDisplayMetrics();
            Bitmap resizedBitmap = Bitmap.createScaledBitmap(bitmap, metrics.widthPixels, metrics.heightPixels, true);

            final WallpaperManager wallpaperManager = WallpaperManager.getInstance(getApplicationContext());

            // Set wallpaper on a background thread to avoid blocking the UI
            new Thread(new Runnable() {
                @Override
                public void run() {
                    try {
                        wallpaperManager.setBitmap(resizedBitmap);

                        // Show Toast on the main thread after setting the wallpaper
                        runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                Toast.makeText(SeeWallapaperActivity.this, "The wallpaper is successfully set.", Toast.LENGTH_SHORT).show();
                            }
                        });

                    } catch (IOException e) {
                        e.printStackTrace();  // Consider logging the error instead of printStackTrace in production
                        Log.e("WallpaperError", "Failed to set wallpaper", e);
                    }
                }
            }).start();

        } else {
            // Handle the case where the drawable is null or not a BitmapDrawable
            Log.e(" wallpaperError", "Drawable is null or not a BitmapDrawable");
        }



    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if (requestCode == REQUEST_WRITE_STORAGE) {
            if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                // Permission granted, proceed with save
                saveButton(imageView);
            } else {
                // Permission denied
                Toast.makeText(this, "Permission Denied", Toast.LENGTH_SHORT).show();
            }
        }
    }

    public void saveButton(ImageView layout) {
        // Create a Bitmap from the CardView
        Bitmap bitmap = Bitmap.createBitmap(layout.getWidth(), layout.getHeight(), Bitmap.Config.ARGB_8888);
        Canvas canvas = new Canvas(bitmap);
        layout.draw(canvas); // Fix: use 'layout' instead of 'cardView2'

        try {
            save(bitmap);
        } catch (IOException e) {
            Toast.makeText(this, "Error saving image: " + e.getMessage(), Toast.LENGTH_LONG).show();
            Log.e(TAG, "Error saving image", e);
        }
    }

    private void save(Bitmap bitmap) throws IOException {
        OutputStream fos;

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.Q) {
            // For Android 10 and above
            ContentResolver resolver = getContentResolver();
            ContentValues contentValues = new ContentValues();
            contentValues.put(MediaStore.MediaColumns.DISPLAY_NAME, "Simple_image_" + System.currentTimeMillis() + ".jpg");
            contentValues.put(MediaStore.MediaColumns.MIME_TYPE, "image/jpeg");
            contentValues.put(MediaStore.MediaColumns.RELATIVE_PATH, Environment.DIRECTORY_PICTURES);

            Uri imageUri = resolver.insert(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, contentValues);
            if (imageUri != null) {
                fos = resolver.openOutputStream(imageUri);
            } else {
                throw new IOException("Failed to create new MediaStore record.");
            }
        } else {
            // For Android 9 and below
            String root = Environment.getExternalStorageDirectory().getAbsolutePath();
            File file = new File(root + "/Pictures");
            if (!file.exists()) {
                file.mkdirs();
            }

            String fileName = "Simple_image_" + System.currentTimeMillis() + ".jpg";
            File myFile = new File(file, fileName);
            if (myFile.exists()) {
                myFile.delete();
            }

            fos = new FileOutputStream(myFile);
        }

        try {
            bitmap.compress(Bitmap.CompressFormat.JPEG, 100, fos);
        } finally {
            fos.flush();
            fos.close();
        }

        Toast.makeText(this, "Image saved successfully", Toast.LENGTH_SHORT).show();
        showHomepageADD();
    }




    private void   showHomepageADD( ) {

        String url = "https://appsallglabal.com/Statuswall/Admob%20Ads%20Control/fullscreenads.php";
        StringRequest stringRequest = new StringRequest(Request.Method.GET, url, new Response.Listener<String>() {
            @Override
            public void onResponse(String response) {

                if (response.contains("on")){

                    if (ManageServer.mInterstitialAd != null) {
                        ManageServer.mInterstitialAd.show(SeeWallapaperActivity.this);
                    } else {
                        Log.d("TAG", "The interstitial ad wasn't ready yet.");
                    }

                }






            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {

            }
        });
        RequestQueue queue = Volley.newRequestQueue(SeeWallapaperActivity.this);

// Add the request to the queue
        queue.add(stringRequest);

    }

}