package com.appsallglobal.statuswalls;

import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.os.Handler;
import android.view.LayoutInflater;
import android.view.View;
import android.view.WindowManager;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.lifecycle.Observer;

import com.appsallglobal.statuswalls.utils.CommonFunction;
import com.google.android.material.button.MaterialButton;

public class SplashScreen extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);





        this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,WindowManager.LayoutParams.FLAG_FULLSCREEN);
        setContentView(R.layout.activity_splash_screen);



        ActionBar actionBar = getSupportActionBar();
        if (actionBar != null){

            actionBar.hide();
        }

        ImageView imageView = findViewById(R.id.logo);
        Animation a = AnimationUtils.loadAnimation(this, R.anim.middle_to_top);
        TextView textView = findViewById(R.id.appName);
        Animation b = AnimationUtils.loadAnimation(this, R.anim.right_to_left);
imageView.setAnimation(a);
textView.setAnimation(b);
        final Handler handler = new Handler();
        handler.postDelayed(new Runnable() {
            @Override
            public void run() {
                //Code here
                if (netWork()) {
                    // ইন্টারনেট আছে, পরবর্তী অ্যাক্টিভিটিতে যান
                    Intent intent = new Intent(SplashScreen.this, MainActivity.class);
                    startActivity(intent);
                    finish(); // স্প্ল্যাশ স্ক্রিন অ্যাক্টিভিটি বন্ধ করুন
                } else {
                    // ইন্টারনেট নেই, এলার্ট ডায়ালগ দেখান
                    new CommonFunction().showNoInternetDialog(SplashScreen.this);
                }
            }
        },3000);

























    }










    private boolean netWork() {
        ConnectivityManager connectivityManager = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        if (connectivityManager != null) {
            NetworkInfo networkInfo = connectivityManager.getActiveNetworkInfo();
            return networkInfo != null && networkInfo.isConnected();
        }
        return false;
    }





    private void showNoInternetDialog() {
        // Inflate the custom layout/view
        LayoutInflater inflater = getLayoutInflater();
        View customView = inflater.inflate(R.layout.no_internet, null);

        // Build the alert dialog
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setView(customView);

        // Prevent the dialog from being dismissed by tapping outside the dialog
        builder.setCancelable(false);

        MaterialButton close = customView.findViewById(R.id.buttonI);
        MaterialButton retry = customView.findViewById(R.id.retryI);

        // Create and show the alert dialog
        AlertDialog alertDialog = builder.create();
        alertDialog.getWindow().setBackgroundDrawableResource(android.R.color.transparent);
        alertDialog.show();

        close.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finishAndRemoveTask(); // Perform action without dismissing dialog from outside touch
            }
        });

        retry.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                recreate(); // Retry action
            }
        });
    }
























}