package com.appsallglobal.statuswalls.utils;

import android.app.Activity;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;

import androidx.appcompat.app.AlertDialog;

import com.appsallglobal.statuswalls.R;
import com.google.android.material.button.MaterialButton;

public class CommonFunction {
    public void showNoInternetDialog(Activity activity) {
        // Ensure this is executed on the main thread
        activity.runOnUiThread(() -> {
            // Check if activity is still running to avoid WindowLeaked exception
            if (activity == null || activity.isFinishing() || activity.isDestroyed()) {
                return; // Do not show dialog if the activity is finishing or destroyed
            }

            // Inflate the custom layout/view
            LayoutInflater inflater = activity.getLayoutInflater();
            View customView = inflater.inflate(R.layout.no_internet, null);

            // Build the alert dialog
            AlertDialog.Builder builder = new AlertDialog.Builder(activity);
            builder.setView(customView);

            // Prevent the dialog from being dismissed by tapping outside the dialog
            builder.setCancelable(false);

            MaterialButton close = customView.findViewById(R.id.buttonI);
            MaterialButton retry = customView.findViewById(R.id.retryI);

            // Create and show the alert dialog
            AlertDialog alertDialog = builder.create();
            alertDialog.getWindow().setBackgroundDrawableResource(android.R.color.transparent);
            alertDialog.show();

            close.setOnClickListener(v -> {
                alertDialog.dismiss();  // Closes the alert dialog
                activity.finishAndRemoveTask(); // Closes the activity and removes it from the recent apps list
            });

            retry.setOnClickListener(v -> {
                alertDialog.dismiss();
                activity.recreate(); // Recreates the activity
            });
        });
    }

// vaiya akhon hoyce but abar method call hebe jehetu network nai i mean abar dailog show hobe

    //  vaiya arek ta arekta item xm make koren ata same to same coppy tarpor retry a dismis dile hobe
}